/*
 * web_queue.h - An empty file. Use it if you wish, don't if you don't.
 * 
 */

#ifndef WEB_QUEUE_H
#define WEB_QUEUE_H 1
/*<solution>*/

/* Note: web_queue_t is not synchronized. If used from multiple
 * threads, it is the users responsibility to provide suitable mutual
 * exclusion.
 */

struct _web_queue;
typedef struct _web_queue* web_queue_t;

/* Create a new, empty queue */
web_queue_t web_new_queue();

/* Destroy the given queue. Asserts that the queue is empty. */
void web_free_queue(web_queue_t queue);

/* Add the given thread to the end of the queue */
void web_enqueue(web_queue_t queue, int conn);

/* Return, and remove, the next thread from the queue, or NULL
 * if queue is empty */
int web_dequeue(web_queue_t queue);

/* Return the number of threads currently in the queue */
int web_queue_size(web_queue_t queue);

/* Return true if queue has no threads, false otherwise */
int web_queue_is_empty(web_queue_t queue);

/*</solution>*/


#endif /* WEB_QUEUE_H */


